/* $Id: page.c,v 1.12 1998/09/17 20:27:34 jared Exp $ */
#include "config.h"

extern int loopvar;
extern int donotify;
extern char *errorsto;

/* Tell someone that the host is down */
void page_someone(struct hostinfo *svc)
{
        int x; /* counter variable */
        time_t t; /* used to get the time */
        FILE *fp; /* file handle used with popen */
	char command[512]; /* command for popen */
        struct passwd *pw; /* password structure */
        char out[256]; /* out */
	char myhostname[80]; /* my hostname */

	gethostname(myhostname, 80); /* get my hostname */

        out[0]='\0';

        /* parse PMESG as follows: */
        /* %m = My host Name */
        /* %s = Service */
        /* %t = Current Time */
	/* %d = downtime dd:hh:mm */
	/* %D = downtime dd:hh:mm:ss */
        /* %w = warning/what */
        /* %h = hostname with failure */
        /*              */

        /* convert to page */
        for (x=0; x < strlen(PMESG);x++)
        {
                if (PMESG[x] == '%')
                {
                        x++;
                        switch (PMESG[x]) 
			{
                                case 'm':
                                        strcat(out, myhostname);
                                        break;
				case 'd': /* downtime */
					strcat(out, str_difftime(svc->deathtime));
					break;
				case 'D': /* downtime 2 */
					strcat(out, str_difftime_sec(svc->deathtime));
                                case 't':
                                        time(&t);
                                        strcat(out, ctime(&t)+4);
                                        out[strlen(out)-6]='\0';
                                        /* time */
                                        break;
                                case 'u':
                                        strcat(out, errtostr(svc->lastcheck));
                                        break;
                                case 'w':
                                        strcat(out, svc->message);
                                        break;
                                case 'h':
                                        strcat(out, svc->hostname);
					if (svc->type != 3)
						strcat(out, "\'s");
                                        break;
                        }
                } 
		else 
                        strncat(out, PMESG+x, 1);
        }

        syslogmsg(out);
	if (strlen(svc->contact) == 0)
		svc->contacted = TRUE;

        if ((strlen(svc->contact) != 0) && (donotify == 0))
        {
                pw = getpwuid(getuid());
		if (pw == NULL)
		{
			perror("page.c:getpwuid");
			return;
		}
		time(&svc->lastcontacted);

		/* setup the command to call (sendmail) */
		snprintf(command, 500, "%s -t", MAIL);

		/* open a connection to sendmail */
                fp = popen(command, "w");

		if (fp == NULL)
		{
			perror("page.c:popen");
			return;
		}

		/* The message */
                fprintf(fp, "From: System Monitor <%s@localhost>\n", 
			pw->pw_name);
                fprintf(fp, "To: %s\n", svc->contact);
		/* Insert Errors-To: headder if necessary */
		if (errorsto != NULL)
			fprintf(fp, "Errors-To: %s\n", errorsto);
		/* Insert Subject line */
		fprintf(fp, "Subject: %s is %s\n", svc->hostname, 
			errtostr(svc->lastcheck));
		/* Body of message */
                fprintf(fp, "%s\n.\n", out);

		/* Close the PIPE */
                pclose(fp);

		/* Set contacted */
                svc->contacted = TRUE;
        }
}
